#!/usr/bin/perl -w

$eemameSize = $ARGV[0];

if (!defined $eemameSize || !($eemameSize =~ /^(full|mini|micro)$/)) {
    die "Usage: list-possible-drivers.pl [full|mini|micro]";
}


open CPUFILE, "<eemame-cpulist.$eemameSize";
@cpus = ();
while (<CPUFILE>) {
    s/\s//g;
    push @cpus, $_ if $_ ne "";
}
close CPUFILE;

open SOUNDFILE, "<eemame-soundlist.$eemameSize";
@sounds = ();
while (<SOUNDFILE>) {
    s/\s//g;
    push @sounds, $_ if $_ ne "";
}
close SOUNDFILE;

#print "CPUs:";
#foreach $i (@cpus) {
#    print " $i";
#}
#print "\n";
#print "SOUNDs:";
#foreach $i (@sounds) {
#    print " $i";
#}
#print "\n";

open GAMESLIST, "<gameslist.txt";
while (<GAMESLIST>) {
    my @line = split "\t", $_;
    my $driver = shift @line;
    my @req = split " ", (shift @line);

    next if grep /MISSING_/, @req;

    my @reqCpus = grep /^(CPU|AUDIO_CPU):/, @req;
    my @reqSounds = grep /^SOUND:/, @req;

    foreach $i (@reqCpus) {
	$i =~ s/^(CPU|AUDIO_CPU):(.*)\@[0-9\.]*MHz$/$2/;
    }
    foreach $i (@reqSounds) {
	$i =~ s/^SOUND://;
    }

    #print "--$driver\n";
    my $hasAll = 1;
    foreach $i (@reqCpus) {
	$hasAll = 0 if !grep /^$i$/, @cpus;
	#print "$i $hasAll\n";
    }
    foreach $i (@reqSounds) {
	$hasAll = 0 if !grep /^$i$/, @sounds;
	#print "$i $hasAll\n";
    }
    print "$driver\n" if $hasAll;
}
