/*******************************************************************
 *
 *	File:		EMameGlobal.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __EMAME_GLOABL_H
#define __EMAME_GLOABL_H

extern "C"
{
#include "driver.h"
}

#include <w32std.h>

const TInt KOptionsFileVersion = 8;
_LIT8(KDefaultOptionsGameName, "default");

class TGameOptions
{
  public:
    enum TGameSize
    {
      EGameSizeNormal = 0,
      EGameSizeFitScreen,
      EGameSizeFitScreenNicely // Slower but nicer
    };

    enum TScreenOrientation
    {
      EScreenOrientationNormal = 0,
      EScreenOrientationRotateRight,
      EScreenOrientationUpsideDown,
      EScreenOrientationRotateLeft
    };

    TBufC8<8> iGameName;
    TGameSize iGameSize;
    TBool iKeepAspectRatio;
    TScreenOrientation iScreenOrientation;
#if defined __UIQ__ || defined __NOKIA7710__
    TBool iVirtualKeyboardEnabled;
#endif
    TBool iSoundEnabled;
    TInt iSoundVolume;
    
    TInt iFrameSkip;
    TBool iAutoFrameSkipEnabled;
    TInt iMaxAutoFrameSkip;
    TBool iThrottleSpeedEnabled;
};

void RunGame(TInt aGame, const TGameOptions& aGameOptions, TInt aAppWindowGroupId);
extern "C" int gForcedExitFromFrontEnd;
void SetResumeFromFrontEnd(TBool aResumeFromFrontEnd);
const TGameOptions& GameOptions();

#endif			/* __EMAME_GLOABL_H */
