/*******************************************************************
 *
 *	File:		Audio.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __AUDIO_H
#define __AUDIO_H

#include <Mda\Client\Resource.h>
#include <Mda\Client\Utility.h>
#include <Mda\Common\Audio.h>
#include <MdaAudioOutputStream.h>

#include <e32base.h>
#include <w32std.h>

const TInt KMaxSoundBuffers = 4;
const TInt KBufferedSamples = 800;

class CGameAudio : public CBase, public MMdaAudioOutputStreamCallback
{
  public:
    static CGameAudio* NewL(TBool aStereo);
    ~CGameAudio();

    TInt Write(TInt16* aBuffer, TInt aSize);

    void SetVolume(TInt attenuation);
    TInt Volume();
    TInt MaxVolume();

  private:
    CGameAudio(TBool aStereo);
    void ConstructL();
    
    void SendBufferIfPossible();
    void WaitForOpenToCompleteL();
    
    virtual void MaoscOpenComplete(TInt aError);
    virtual void MaoscBufferCopied(TInt aError, const TDesC8& aBuffer);
    virtual void MaoscPlayComplete(TInt aError);

    TBool iStereo;
    CMdaAudioOutputStream *iMdaAudioOutputStream;
    TMdaAudioDataSettings iMdaAudioDataSettings;
    TBool iIsOpen;

    TUint16 *iSoundBuffers[KMaxSoundBuffers];
    TPtrC8 iSentBuffers[KMaxSoundBuffers];
    TInt iCurrentBuffer;
    TInt iCurrentPosition;

    TInt iNextBufferToSend;
    TInt iNoOfOutstandingBuffers;
};


#endif			/* __AUDIO_H */
